/*
 * DESCRIPTION:
 * text.c header.
*/

#pragma once

#include "font.h"
#include "texture.h"
#include "surface.h"

struct GlyphMetrics
{
	s32 minX;
	s32 minY;
	s32 maxX;
	s32 maxY;
	s32 advance;
};

static const SDL_Color GLYPH_COLOR = {255, 255, 255, 255};

s32 glyph_width_get(struct Font* font, char glyph);
s32 glyph_kerning_get(struct Font* font, char glyph, char nextGlyph);
bool glyph_texture_init(struct Texture* texture, struct Font* font, char glyph);
void glyph_metrics_get(struct GlyphMetrics* self, struct Font* font, char glyph);
