/*
 * DESCRIPTION:
 * File writing/reading.
*/

#include "io.h"

/* Opens a file for reading. */
bool
file_read(char* path, char* buffer, size_t size)
{
	SDL_RWops* io;

	if (!path || !buffer)
		return false;

	io = SDL_RWFromFile(path, "r");

	if (!io)
		return false;

	SDL_RWread(io, buffer, size, 1);

	SDL_RWclose(io);

	return true;
}

/* Writes data to a file. */
bool
file_write(char* path, void* data, size_t size)
{
	SDL_RWops* io;

	if (!path || !data)
		return false;

	io = SDL_RWFromFile(path, "w");

	if (!io)
		return false;

	SDL_RWwrite(io, data, size, 1);

	return true;
}
