#include "keyboard.h"

/* Updates the keyboard. */
void
keyboard_update(struct Keyboard* self)
{
	const u8* state;

	memcpy(&self->prev, &self->curr, sizeof(u8) * KEY_COUNT);
	memset(&self->curr, '\0', sizeof(u8) * KEY_COUNT);

	state = SDL_GetKeyboardState(NULL);

	memcpy(&self->curr, state, KEY_COUNT);
}

/* Is the given key pressed? */
bool
keyboard_press(struct Keyboard* self, enum KeyType type)
{
	return (self->curr[type] && !self->prev[type]);
}

/* Is the given key held? */
bool
keyboard_held(struct Keyboard* self, enum KeyType type)
{
	return (self->curr[type] && self->prev[type]);
}

/* Is the given key released? */
bool
keyboard_release(struct Keyboard* self, enum KeyType type)
{
	return (!self->curr[type] && self->prev[type]);
}
