/*
 * DESCRIPTION:
 * mouse.c header.
*/

#pragma once

#include <SDL2/SDL.h>

#include "../util/UTIL.h"

#define MOUSE_COUNT MOUSE_RIGHT + 1
enum MouseType
{
	MOUSE_NONE,
	MOUSE_LEFT,
	MOUSE_MIDDLE,
	MOUSE_RIGHT
};

struct Mouse
{
	vec2 position;
	bool curr[MOUSE_COUNT];
	bool prev[MOUSE_COUNT];
};

void mouse_update(struct Mouse* self);
bool mouse_press(struct Mouse* self, enum MouseType type);
bool mouse_held(struct Mouse* self, enum MouseType type);
bool mouse_release(struct Mouse* self, enum MouseType type);
