/*
 * DESCRIPTION:
 * renderer.c header.
*/

#pragma once

#include "atlas.h"
#include "camera.h"
#include "glew.h"
#include "shader.h"
#include "vao.h"
#include "vbo.h"
#include "vertexattribute.h"

#define RENDERER_CAMERA_PERSPECTIVE_FOV_DEFAULT 90.0f
#define RENDERER_CAMERA_PERSPECTIVE_ASPECT_DEFAULT 1.0f

struct Renderer
{
	SDL_GLContext glContext;
	struct Camera camera;
	struct Window* window;
	struct Shader* shader;
	struct VAO vao;
	struct VBO ebo;
	struct VBO vbo;
	vec4 clearColor;
};

void renderer_init(struct Renderer* self, struct Window* window, enum CameraType type);
void renderer_clear_color_set(struct Renderer* self, vec4 color);
void renderer_viewport_window_set(struct Renderer* self);
void renderer_viewport_set(struct Renderer* self, ivec4 viewport);
void renderer_clear(struct Renderer* self);
void renderer_update(struct Renderer* self);
void renderer_free(struct Renderer* self);
void renderer_present(struct Renderer* self);
void renderer_shader_use(struct Renderer* self, struct Shader* shader);
