/*
 * DESCRIPTION:
 * shader.c header.
*/

#pragma once

#include <GL/glew.h>
#include <GL/gl.h>

#include "texture.h"

#define SHADER_LOG_MAX 1024

struct Shader 
{
	GLuint handle;
	bool isInit;
};

bool shader_init(struct Shader* self, char* vertex, char* fragment);
void shader_use(struct Shader* self);
void shader_free(struct Shader* self);
void shader_uniform_f32_set(struct Shader* self, char* name, f32 value);
void shader_uniform_s32_set(struct Shader* self, char* name, s32 value);
void shader_uniform_mat4_set(struct Shader* self, char* name, mat4 value);
void shader_uniform_vec3_set(struct Shader* self, char* name, vec3 value);
void shader_uniform_vec4_set(struct Shader* self, char* name, vec4 value);
void shader_uniform_texture_set(struct Shader* self, char* name, struct Texture* texture, s32 index);
