/*
 * DESCRIPTION:
 * texture.c header.
*/

#pragma once

#include <GL/glew.h>
#include <GL/gl.h>

#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_ttf.h>

#include "../util/UTIL.h"

struct Texture
{
	GLuint handle;
	s32 w;
	s32 h;
	s32 channels;
	bool isInit;
};

bool texture_init(struct Texture* self, char* path);
bool texture_surface_init(struct Texture* self, struct SDL_Surface* surface);
void texture_bind(struct Texture* self);
void texture_free(struct Texture* self);
