/*
 * DESCRIPTION:
 * OpenGL Vertex Array Object (VAO) abstractions.
*/

#include "vao.h"

/* Initializes a VAO. */
void
vao_init(struct VAO* self)
{
	glGenVertexArrays(1, &self->handle);
}

/* Binds VAO. */
void
vao_bind(struct VAO* self)
{
	glBindVertexArray(self->handle);
}

/* Unbinds VAO. */
void
vao_unbind(void)
{
	glBindVertexArray(0);
}

/* Frees VAO. */
void
vao_free(struct VAO* self)
{
	glDeleteVertexArrays(1, &self->handle);
	memset(self, '\0', sizeof(struct VAO));
}
