/*
 * DESCRIPTION:
 * window.c header.
*/

#pragma once

#include <SDL2/SDL.h>

#include "../util/UTIL.h"

struct Window
{
	struct SDL_Window* sdl;
	char* name;
	u32 flags;
	vec2 size;
	bool isFullscreen;
};

void window_init(struct Window* self, char* name, vec2 size, u32 flags);
void window_free(struct Window* self);
void window_update(struct Window* self);
void window_fullscreen_enter(struct Window* self);
void window_fullscreen_exit(struct Window* self);
void window_fullscreen_toggle(struct Window* self);
void window_ivec4_get(struct Window* self, ivec4 vector);
void window_coords_to_gl(struct Window* self, vec2 position, vec2 dest);
