/*
 * DESCRIPTION:
 * ECS types.
*/

#pragma once

#include "../../util/UTIL.h"

#define ECS_FUNCTION_COUNT ECS_FUNCTION_DRAW + 1
enum ECSFunctionType
{
	ECS_FUNCTION_ADD,
	ECS_FUNCTION_DELETE,
	ECS_FUNCTION_UPDATE_F,
	ECS_FUNCTION_UPDATE_V,
	ECS_FUNCTION_DRAW
};

#define ECS_C_COUNT ECS_C_UI_BUTTON + 1
enum ECSComponentType
{
	ECS_C_CHASE,
	ECS_C_CIRCLE,
	ECS_C_CIRCLE_COLLIDE,
	ECS_C_COLOR,
	ECS_C_COLOR_CHANGE,
	ECS_C_COLOR_COLLIDE_DELETE,
	ECS_C_CONTACT_DAMAGE,
	ECS_C_CONTROL,
	ECS_C_DAMAGE,
	ECS_C_FLASH,
	ECS_C_GAME_OBJECT,
	ECS_C_HEALTH,
	ECS_C_MOVE,
	ECS_C_ORBIT,
	ECS_C_PARTICLE_SPAWN,
	ECS_C_PHYSICS,
	ECS_C_PLAYER_ATLAS_HEALTH,
	ECS_C_PLAYER_DEATH,
	ECS_C_PULSATE,
	ECS_C_ROTATION,
	ECS_C_SCALE,
	ECS_C_SPIN,
	ECS_C_SPRITE,
	ECS_C_STUN,
	ECS_C_TEXT,
	ECS_C_TIME_DELETE,
	ECS_C_UI_BUTTON
};

struct ECS;

typedef void (*ECSRegister)(void);
typedef void (*ECSFunction)(void*);

struct ECSSystem
{
	ECSFunction functions[ECS_FUNCTION_COUNT];
};

struct ECSComponentList
{
	struct ECSSystem system;
	struct Vector components;
	enum ECSComponentType type;
};

struct ECS
{
	struct ECSComponentList lists[ECS_C_COUNT];
	u32 nextID;
};
