/*
 * DESCRIPTION:
 * c_color.c header.
*/

#pragma once

#include "entity.h"

#define C_COLOR_LIMIT 0xFF

#define C_COLOR_COUNT C_COLOR_CYAN + 1
enum CColorType
{
	C_COLOR_GREEN,
	C_COLOR_BLUE,
	C_COLOR_RED,
	C_COLOR_YELLOW,
	C_COLOR_MAGENTA,
	C_COLOR_CYAN
};

struct CColor
{
	u32 id;
	enum CColorType type;
};

static const vec4 C_COLOR_VALUES[C_COLOR_COUNT] = 
{
	{0.30f, 1.00f, 0.30f, 1.00f},
	{0.20f, 0.50f, 0.80f, 1.00f},
	{1.00f, 0.20f, 0.20f, 1.00f},
	{1.00f, 1.00f, 0.30f, 1.00f},
	{1.00f, 0.20f, 0.90f, 1.00f},
	{0.20f, 1.00f, 0.90f, 1.00f}
};

void c_color_set(struct CColor* self, enum CColorType type);
void c_color_register(void);
