/*
 * DESCRIPTION:
 * c_color_change.c header.
*/

#pragma once

#include "c_sprite.h"
#include "c_text.h"

#define C_COLOR_CHANGE_LIMIT 0xFF

#define C_COLOR_CHANGE_COUNT C_COLOR_CHANGE_STICK + 1
enum CColorChangeType
{
	C_COLOR_CHANGE_TO,
	C_COLOR_CHANGE_FROM,
	C_COLOR_CHANGE_TO_STICK,
	C_COLOR_CHANGE_FROM_STICK
};

struct CColorChange
{
	u32 id;
	vec4 baseColor;
	vec4 color;
	s32 timer;
	s32 timerMax;
	bool isFinished;
	enum CColorChangeType type;
};

void c_color_change_set(struct CColorChange* self, vec4 baseColor, vec4 color, s32 timerMax, enum CColorChangeType type);
void c_color_change_register(void);
