/*
 * DESCRIPTION:
 * Contact damage component.
*/

#include "c_contact_damage.h"

static void update_f(struct CContactDamage* self);

/* Draws a contact damage component. */
static void
update_f(struct CContactDamage* self)
{
	struct CCircleCollide* circleCollide;

	circleCollide = ecs_get(self->id, ECS_C_CIRCLE_COLLIDE);

	if (!circleCollide)
		return;

	for (s32 i = 0; i < (s32)circleCollide->collisions.count; i++)
	{
		struct CDamage* damage;
		u32* id;

		id = (u32*)vector_get(&circleCollide->collisions, i);

		damage = ecs_get(*id, ECS_C_DAMAGE);

		if (!damage || damage->isDisabled)
			continue;

		damage->isDamaged = true;
		break;
	}
}

/* Registers contact damage component. */
void
c_contact_damage_register(void)
{
	ecs_register
	(
		ECS_C_CONTACT_DAMAGE,
		sizeof(struct CContactDamage),
		C_CONTACT_DAMAGE_LIMIT,
		NULL,
		NULL,
		(ECSFunction)update_f,
		NULL,
		NULL
	);
}
