/*
 * DESCRIPTION:
 * c_flash.c header.
*/

#pragma once

#include "entity.h"

#define C_FLASH_LIMIT 0xFF

#define C_FLASH_COUNT C_FLASH_STROBE + 1
enum CFlashType
{
	C_FLASH_VANISH,
	C_FLASH_APPEAR,
	C_FLASH_STROBE,
	C_FLASH_CONSTANT
};

struct CFlash
{
	u32 id;
	bool isFinished;
	enum CFlashType type;
	s32 timer;
	s32 timerMax;
	vec4 baseColor;
	vec4 color;
};

void c_flash_set(struct CFlash* self, vec4 baseColor, vec4 color, s32 timerMax, enum CFlashType type);
void c_flash_register(void);
