/*
 * DESCRIPTION:
 * c_game_object.c header.
*/

#pragma once

#include "c_circle.h"
#include "c_physics.h"
#include "c_sprite.h"

#define C_GAME_OBJECT_LIMIT 0xFF

struct CGameObject
{
	u32 id;
};

void c_game_object_register(void);

void c_game_object_set
(
	struct CGameObject* self, 
	struct Texture texture,
	enum ShaderType shader,
	enum OriginType origin,
	vec2 size,
	vec3 position,
	vec4 color,
	f32 friction,
	f32 velocityMax,
	f32 radius
);

void c_game_object_atlas_set
(
	struct CGameObject* self, 
	struct Texture texture,
	enum ShaderType shader,
	enum OriginType origin,
	s32 frameW,
	s32 frameH,
	s32 rows,
	s32 cols,
	vec2 size,
	vec3 position,
	vec4 color,
	f32 friction,
	f32 velocityMax,
	f32 radius
);
