/*
 * DESCRIPTION:
 * Health component.
*/

#include "c_health.h"

static void update_f(struct CHealth* self);

/* Draws a health component. */
static void
update_f(struct CHealth* self)
{
	if (self->current <= 0)
	{
		self->current = 0;
		self->isDead = true;
	}
	else
		self->isDead = false;
}

/* Sets health component. */
void
c_health_set(struct CHealth* self, s32 max)
{
	self->max = max;
	self->current = self->max;
	self->isDead = false;
}

/* Registers health component. */
void
c_health_register(void)
{
	ecs_register
	(
		ECS_C_HEALTH,
		sizeof(struct CHealth),
		C_HEALTH_LIMIT,
		NULL,
		NULL,
		(ECSFunction)update_f,
		NULL,
		NULL
	);
}
