/*
 * DESCRIPTION:
 * c_move.c header.
*/

#pragma once

#include "c_sprite.h"
#include "c_text.h"

#define C_MOVE_LIMIT 0xFF

#define C_MOVE_COUNT C_MOVE_FROM_STICK + 1
enum CMoveType
{
	C_MOVE_TO,
	C_MOVE_FROM,
	C_MOVE_TO_STICK,
	C_MOVE_FROM_STICK,
};

struct CMove
{
	u32 id;
	vec3 start;
	vec3 end;
	s32 timer;
	s32 timerMax;
	bool isFinished;
	enum CMoveType type;
};

void c_move_set(struct CMove* self, vec3 start, vec3 end, s32 timerMax, enum CMoveType type);
void c_move_register(void);
