/*
 * DESCRIPTION:
 * c_particle_spawn.c header.
*/

#pragma once

#include "e_particle.h"

#define C_PARTICLE_SPAWN_LIMIT 0xFF

#define PARTICLE_SPAWN_SCALE 2.0f
#define PARTICLE_SPAWN_SPIN_SPEED_MIN -0.01f
#define PARTICLE_SPAWN_SPIN_SPEED_MAX 0.01f
#define PARTICLE_SPAWN_TIMER 20

static const vec4 PARTICLE_SPAWN_BIG_PARTICLE_BASE_COLOR = {1.0f, 1.0f, 1.0f, 0.5f};
static const vec4 PARTICLE_SPAWN_LIL_PARTICLE_BASE_COLOR = {1.0f, 1.0f, 1.0f, 1.0f};
static const vec2 PARTICLE_SPAWN_BIG_PARTICLE_SIZE = {30.0f, 30.0f};
static const vec2 PARTICLE_SPAWN_LIL_PARTICLE_SIZE = {15.0f, 15.0f};

struct CParticleSpawn
{
	u32 id;
};

void c_particle_spawn(struct CParticleSpawn* self, vec3 position);
void c_particle_spawn_register(void);
