/*
 * DESCRIPTION:
 * Player atlas health component.
 * Changes the player's atlas frame in conjunction with its health.
*/

#include "c_player_atlas_health.h"

static void update_f(struct CPlayerAtlasHealth* self);

/* Draws a player_atlas_health component. */
static void
update_f(struct CPlayerAtlasHealth* self)
{
	struct CSprite* sprite;
	struct CHealth* health;

	sprite = ecs_get(self->id, ECS_C_SPRITE);
	health = ecs_get(self->id, ECS_C_HEALTH);

	if (!sprite || !health)
		return;

	sprite->atlas.index = health->max - health->current;
}

/* Registers player_atlas_health component. */
void
c_player_atlas_health_register(void)
{
	ecs_register
	(
		ECS_C_PLAYER_ATLAS_HEALTH,
		sizeof(struct CPlayerAtlasHealth),
		C_PLAYER_ATLAS_HEALTH_LIMIT,
		NULL,
		NULL,
		(ECSFunction)update_f,
		NULL,
		NULL
	);
}
