/*
 * DESCRIPTION:
 * c_player_death.c header.
*/

#pragma once

#include "c_color_change.h"
#include "c_color_collide_delete.h"
#include "c_control.h"
#include "c_health.h"
#include "c_orbit.h"
#include "c_pulsate.h"
#include "c_scale.h"
#include "c_time_delete.h"

#define C_PLAYER_DEATH_LIMIT 0xFF
#define C_PLAYER_DEATH_PULSATE_TIME 20
#define C_PLAYER_DEATH_GROW_TIME 80
#define C_PLAYER_DEATH_VANISH_TIME 80
#define C_PLAYER_DEATH_GROW_SCALE_BASE_VALUE 1.0f
#define C_PLAYER_DEATH_GROW_SCALE_VALUE 3.0f
#define C_PLAYER_DEATH_VANISH_SCALE_BASE_VALUE 3.0f
#define C_PLAYER_DEATH_VANISH_SCALE_VALUE -3.0f
#define C_PLAYER_DEATH_FOLLOWER_SCALE 2.0f
#define C_PLAYER_DEATH_FOLLOWER_BASE_SCALE 1.0f
#define C_PLAYER_DEATH_FOLLOWER_TIMER 30

static const vec4 C_PLAYER_DEATH_FOLLOWER_COLOR = {1.0f, 1.0f, 1.0f, 0.0f};
static const vec4 C_PLAYER_DEATH_GROW_COLOR_CHANGE_BASE_COLOR = {1.0f, 1.0f, 1.0f, 1.0f};
static const vec4 C_PLAYER_DEATH_GROW_COLOR_CHANGE_COLOR = {1.0f, 0.0f, 0.0f, 0.5f};
static const vec4 C_PLAYER_DEATH_VANISH_COLOR_CHANGE_BASE_COLOR = {1.0f, 0.0f, 0.0f, 0.5f};
static const vec4 C_PLAYER_DEATH_VANISH_COLOR_CHANGE_COLOR = {0.0f, 0.0f, 0.0f, 0.0f};

#define C_PLAYER_DEATH_STATE_COUNT C_PLAYER_DEATH_END + 1
enum CPlayerDeathState
{
	C_PLAYER_DEATH_NONE,
	C_PLAYER_DEATH_PULSATE,
	C_PLAYER_DEATH_GROW,
	C_PLAYER_DEATH_VANISH,
	C_PLAYER_DEATH_END
};

struct CPlayerDeath
{
	u32 id;
	enum CPlayerDeathState state;
	s32 timer;
};

void c_player_death_register(void);
