/*
 * DESCRIPTION:
 * c_scale.c header.
*/

#pragma once

#include "c_sprite.h"
#include "c_text.h"

#define C_SCALE_LIMIT 0xFF
#define C_SCALE_DEFAULT 1.0f

#define C_SCALE_COUNT C_SCALE_FROM_STICK + 1
enum CScaleType
{
	C_SCALE_TO,
	C_SCALE_FROM,
	C_SCALE_TO_STICK,
	C_SCALE_FROM_STICK,
};

struct CScale
{
	u32 id;
	f32 value;
	f32 baseValue;
	s32 timer;
	s32 timerMax;
	bool isFinished;
	enum CScaleType type;
};

void c_scale_set(struct CScale* self, f32 baseValue, f32 value, s32 timerMax, enum CScaleType type);
void c_scale_register(void);
