/*
 * DESCRIPTION:
 * Spin component.
*/

#include "c_spin.h"

static void update_f(struct CSpin* self);

/* Updates an spin component. */
static void
update_f(struct CSpin* self)
{
	struct CSprite* sprite;

	sprite = ecs_get(self->id, ECS_C_SPRITE);

	if (!sprite)
		return;

	sprite->rotation += self->speed;
}

/* Sets spin component. */
void
c_spin_set(struct CSpin* self, f32 speed)
{
	self->speed = speed;
}

/* Registers spin component. */
void
c_spin_register(void)
{
	ecs_register
	(
		ECS_C_SPIN,
		sizeof(struct CSpin),
		C_SPIN_LIMIT,
		NULL,
		NULL,
		(ECSFunction)update_f,
		NULL,
		NULL
	);
}
