/*
 * DESCRIPTION:
 * c_sprite.c header.
*/

#pragma once

#include "../shader/shader_texture_quad.h"

#include "entity.h"

#define C_SPRITE_LIMIT 0xFF
#define C_SPRITE_SCALE_DEFAULT 1.0f

struct CSprite
{
	u32 id;
	struct Atlas atlas;
	enum ShaderType shader;
	enum OriginType origin;
	vec2 size;
	vec3 position;
	vec4 color;
	f32 scale;
	f32 rotation;
};

static const vec3 C_SPRITE_ROTATION_AXIS = {0.0f, 0.0f, 1.0f};

void c_sprite_rectangle_get(struct CSprite* self, vec4 rectangle);

void c_sprite_set
(
	struct CSprite* self, 
	struct Texture texture, 
	enum ShaderType shader, 
	enum OriginType origin,
	vec2 size, 
	vec4 color, 
	vec3 position
);

void c_sprite_atlas_set
(
	struct CSprite* self, 
	struct Texture texture, 
	enum ShaderType shader,
	enum OriginType origin,
	s32 frameW,
	s32 frameH, 
	s32 rows, 
	s32 cols, 
	vec2 size, 
	vec4 color, 
	vec3 position
);

void c_sprite_register(void);
