/*
 * DESCRIPTION:
 * c_text.c header.
*/

#pragma once

#include "../shader/shader_texture_quad.h"

#include "entity.h"

#define C_TEXT_LIMIT 0xFF
#define C_TEXT_STRING_LIMIT 0xFF
#define C_TEXT_SCALE_DEFAULT 1.0f

struct CText
{
	u32 id;
	struct Font font;
	struct Texture glyphTextures[C_TEXT_STRING_LIMIT];
	char string[C_TEXT_STRING_LIMIT];
	enum ShaderType shader;
	enum OriginType origin;
	s32 length;
	s32 wrap;
	vec3 position;
	vec4 color;
	f32 scale;
};

void c_text_rectangle_get(struct CText* self, vec4 rectangle);
void c_text_string_set(struct CText* self, char* string, s32 length);

void c_text_set
(
	struct CText* self, 
	enum ShaderType shader, 
	enum OriginType origin,
	struct Font font,
	char* string,
	s32 length,
	s32 wrap,
	vec4 color, 
	vec3 position
);

void c_text_register(void);
