/*
 * DESCRIPTION:
 * Time delete component.
 * Deletes an entity when the timer elapses.
*/

#include "c_time_delete.h"

static void add(struct CTimeDelete* self);
static void update_f(struct CTimeDelete* self);

/* Adds a time_delete component. */
static void
add(struct CTimeDelete* self)
{
	self->isDisabled = true;
}

/* Draws a time_delete component. */
static void
update_f(struct CTimeDelete* self)
{
	if (self->isDisabled)
		return;

	self->timer--;

	if (self->timer <= 0)
		entity_delete(self->id);
}

/* Sets TimeDelete component. */
void
c_time_delete_set(struct CTimeDelete* self, s32 timer)
{
	self->timer = timer;
	self->isDisabled = false;
}

/* Registers time_delete component. */
void
c_time_delete_register(void)
{
	ecs_register
	(
		ECS_C_TIME_DELETE,
		sizeof(struct CTimeDelete),
		C_TIME_DELETE_LIMIT,
		(ECSFunction)add,
		NULL,
		(ECSFunction)update_f,
		NULL,
		NULL
	);
}
