/*
 * DESCRIPTION:
 * Enemy code.
*/

#include "e_enemy.h"

/* Initializes an enemy. */
void
enemy_init(u32 id, u32 targetID, enum CColorType colorType, vec3 position, f32 speed)
{
	struct CGameObject* object;
	struct CChase* chase;
	struct CSpin* spin;
	struct CColor* color;

	object = ecs_add(id, ECS_C_GAME_OBJECT);
	chase = ecs_add(id, ECS_C_CHASE);
	spin = ecs_add(id, ECS_C_SPIN);
	color = ecs_add(id, ECS_C_COLOR);
	ecs_add(id, ECS_C_CONTACT_DAMAGE);
	ecs_add(id, ECS_C_PARTICLE_SPAWN);

	c_game_object_set
	(
		object, 
		game.textures[TEXTURE_ENEMY],
		ENEMY_SHADER,
		ENEMY_ORIGIN,
		ENEMY_SIZE,
		position,
		C_COLOR_VALUES[colorType],
		ENEMY_FRICTION,
		ENEMY_VELOCITY_MAX,
		ENEMY_RADIUS
	);

	c_chase_set(chase, targetID, speed);

	c_spin_set(spin, ENEMY_SPIN_SPEED);

	c_color_set(color, colorType);
}
