/*
 * DESCRIPTION: 
 * e_enemy.c header.
*/

#pragma once

#include "c_chase.h"
#include "c_color.h"
#include "c_game_object.h"
#include "c_spin.h"

#define ENEMY_FRICTION 0.95f
#define ENEMY_ALPHA_TIMER_MAX 60
#define ENEMY_RADIUS 16.0f
#define ENEMY_SPIN_SPEED 0.05f
#define ENEMY_VELOCITY_MAX 20.0f
#define ENEMY_CHASE_SPEED 0.015f
#define ENEMY_SHADER SHADER_TEXTURE_QUAD
#define ENEMY_ORIGIN ORIGIN_CENTER

static const vec2 ENEMY_SIZE = {25.0f, 25.0f};

void enemy_init(u32 id, u32 targetID, enum CColorType colorType, vec3 position, f32 speed);
