/*
 * DESCRIPTION:
 * Follower code.
*/

#include "e_follower.h"

/* Initialize a player. */
void
follower_init(u32 id, enum CColorType colorType)
{
	struct CGameObject* object;
	struct CColorChange* colorChange;
	struct CColor* color;
	struct CScale* scale;

	color = ecs_add(id, ECS_C_COLOR);
	colorChange = ecs_add(id, ECS_C_COLOR_CHANGE);
	object = ecs_add(id, ECS_C_GAME_OBJECT);
	scale = ecs_add(id, ECS_C_SCALE);
	ecs_add(id, ECS_C_COLOR_COLLIDE_DELETE);
	ecs_add(id, ECS_C_TIME_DELETE);

	c_game_object_set
	(
		object, 
		game.textures[TEXTURE_FOLLOWER],
		FOLLOWER_SHADER,
		FOLLOWER_ORIGIN,
		FOLLOWER_SIZE,
		FOLLOWER_POSITION,
		C_COLOR_VALUES[colorType],
		FOLLOWER_FRICTION,
		FOLLOWER_VELOCITY_MAX,
		FOLLOWER_RADIUS
	);

	c_color_change_set
	(
		colorChange, 
		C_COLOR_VALUES[colorType],
		FOLLOWER_COLOR_CHANGE_COLOR,
		FOLLOWER_COLOR_CHANGE_TIMER_MAX,
		C_COLOR_CHANGE_FROM
	);

	c_scale_set
	(
	 	scale, 
		FOLLOWER_SCALE_BASE_VALUE, 
		FOLLOWER_SCALE_VALUE, 
		FOLLOWER_SCALE_TIMER_MAX, 
		FOLLOWER_SCALE_TYPE
	);

	c_color_set(color, colorType);
}
