/*
 * DESCRIPTION: 
 * e_follower.c header.
*/

#pragma once

#include "c_color_change.h"
#include "c_color_collide_delete.h"
#include "c_game_object.h"

#define FOLLOWER_FRICTION 0.95f
#define FOLLOWER_VELOCITY_MAX 5.0f
#define FOLLOWER_COLOR_CHANGE_TIMER_MAX 60
#define FOLLOWER_RADIUS 30.0f
#define FOLLOWER_SCALE_TIMER_MAX 30
#define FOLLOWER_SCALE_VALUE -1.0f
#define FOLLOWER_SCALE_BASE_VALUE 1.0f
#define FOLLOWER_SCALE_TYPE C_SCALE_FROM
#define FOLLOWER_SHADER SHADER_TEXTURE_QUAD
#define FOLLOWER_ORIGIN ORIGIN_CENTER

static const vec2 FOLLOWER_SIZE = {30.0f, 30.0f};
static const vec3 FOLLOWER_POSITION = {0.0f, 0.0f, 0.0f};
static const vec4 FOLLOWER_COLOR_CHANGE_COLOR = {1.0f, 1.0f, 1.0f, 0.0f};

void follower_init(u32 id, enum CColorType colorType);
