/*
 * DESCRIPTION:
 * Menu screen logo.
*/

#include "e_logo.h"

/* Initializes logo. */
void
logo_init(u32 id)
{
	struct CSprite* sprite;
	struct CMove* move;
	struct CColorChange* colorChange;

	sprite = ecs_add(id, ECS_C_SPRITE);
	move = ecs_add(id, ECS_C_MOVE);
	colorChange = ecs_add(id, ECS_C_COLOR_CHANGE);

	c_sprite_set
	(
		sprite,
		game.textures[TEXTURE_LOGO],
		LOGO_SHADER,
		LOGO_ORIGIN,
		LOGO_SIZE,
		LOGO_COLOR_CHANGE_BASE_COLOR,
		LOGO_MOVE_START
	);

	c_color_change_set
	(
		colorChange,
		LOGO_COLOR_CHANGE_BASE_COLOR,
		LOGO_COLOR_CHANGE_COLOR,
		LOGO_TIMER,
		C_COLOR_CHANGE_TO_STICK
	);

	c_move_set
	(
		move,
		LOGO_MOVE_START,
		LOGO_MOVE_END,
		LOGO_TIMER,
		C_MOVE_TO_STICK
	);
}
