/*
 * DESCRIPTION:
 * Enemy code.
*/

#include "e_particle.h"

/* Initializes an particle. */
void
particle_init
(
	u32 id, 
	vec3 position, 
	vec4 baseColor, 
	vec4 color,
	vec2 size,
	f32 scaleValue,
	f32 spinSpeed,
	s32 timer
)
{
	struct CColorChange* colorChange;
	struct CSprite* sprite;
	struct CScale* scale;
	struct CSpin* spin;
	struct CTimeDelete* timeDelete;

	colorChange = ecs_add(id, ECS_C_COLOR_CHANGE);
	sprite = ecs_add(id, ECS_C_SPRITE);
	scale = ecs_add(id, ECS_C_SCALE);
	spin = ecs_add(id, ECS_C_SPIN);
	timeDelete = ecs_add(id, ECS_C_TIME_DELETE);

	c_sprite_set
	(
		sprite,
		game.textures[TEXTURE_PARTICLE],
		PARTICLE_SHADER,
		PARTICLE_ORIGIN,
		size,
		COLOR_OPAQUE,
		position
	);

	c_spin_set(spin, spinSpeed);

	c_time_delete_set(timeDelete, timer);

	c_scale_set(scale, PARTICLE_SCALE_BASE_VALUE, scaleValue, timer, PARTICLE_SCALE_MODE);

	c_color_change_set
	(
		colorChange, 
		baseColor,
		color,
		timer, 
		C_COLOR_CHANGE_TO_STICK
	);
}
