/*
 * DESCRIPTION: 
 * e_particle.c header.
*/

#pragma once

#include "c_game_object.h"
#include "c_spin.h"
#include "c_time_delete.h"
#include "c_scale.h"
#include "c_color_change.h"

#define PARTICLE_FRICTION 1.00f
#define PARTICLE_VELOCITY_MAX 1.0f
#define PARTICLE_RADIUS 0.0f
#define PARTICLE_SPIN_SPEED_MIN -0.05f
#define PARTICLE_SPIN_SPEED_MAX 0.05f
#define PARTICLE_SCALE_VALUE 2.0f
#define PARTICLE_SCALE_MODE C_SCALE_TO
#define PARTICLE_SHADER SHADER_TEXTURE_QUAD
#define PARTICLE_SCALE_BASE_VALUE 1.0f
#define PARTICLE_ORIGIN ORIGIN_CENTER

void particle_init
(
	u32 id, 
	vec3 position, 
	vec4 baseColor, 
	vec4 color, 
	vec2 size, 
	f32 scaleValue, 
	f32 spinSpeed, 
	s32 timer
);
