/*
 * DESCRIPTION: 
 * e_player.c header.
*/

#pragma once

#include "c_control.h"
#include "c_damage.h"
#include "c_flash.h"
#include "c_health.h"
#include "c_orbit.h"
#include "c_player_atlas_health.h"
#include "c_player_death.h"
#include "c_pulsate.h"
#include "c_rotation.h"
#include "c_stun.h"
#include "e_follower.h"

#define PLAYER_FRICTION 0.70f
#define PLAYER_CONTROL_SPEED 0.01f
#define PLAYER_CONTROL_MOVE_MINIMUM 0.01f
#define PLAYER_VELOCITY_MAX 5.0f
#define PLAYER_ROTATION_SPEED 0.0025f
#define PLAYER_ROTATION_SPEED_MAX 0.05f
#define PLAYER_ROTATION_FRICTION 0.975f
#define PLAYER_FOLLOWER_COUNT 6
#define PLAYER_RADIUS 20.0f
#define PLAYER_COLOR COLOR_OPAQUE
#define PLAYER_HEALTH_MAX 3
#define PLAYER_ORBIT_OFFSET 100.0f
#define PLAYER_PULSATE_BASE_SCALE 1.0f
#define PLAYER_PULSATE_VALUE 0.1f
#define PLAYER_PULSATE_TIMER_MAX 20
#define PLAYER_SHADER SHADER_TEXTURE_QUAD
#define PLAYER_ORIGIN ORIGIN_CENTER

#define PLAYER_ATLAS_ROWS 1
#define PLAYER_ATLAS_COLUMNS 4
#define PLAYER_ATLAS_FRAME_WIDTH 64
#define PLAYER_ATLAS_FRAME_HEIGHT 64

static const vec2 PLAYER_SIZE = {40.0f, 40.0f};

void player_follower_add(u32 id);

void player_init(u32 id, vec3 position);
