/*
 * DESCRIPTION:
 * Warning code.
*/

#include "e_warning.h"

/* Initializes a warning. */
void
warning_init(u32 id, vec3 position, enum CColorType color)
{
	struct CColorChange* colorChange;
	struct CSprite* sprite;
	struct CTimeDelete* timeDelete;

	colorChange = ecs_add(id, ECS_C_COLOR_CHANGE);
	sprite = ecs_add(id, ECS_C_SPRITE);
	timeDelete = ecs_add(id, ECS_C_TIME_DELETE);

	c_sprite_set
	(
		sprite, 
		game.textures[TEXTURE_WARNING],
		WARNING_SHADER,
		WARNING_ORIGIN,
		WARNING_SIZE,
		C_COLOR_VALUES[color],
		position
	);

	c_color_change_set
	(
		colorChange, 
		C_COLOR_VALUES[color],
		COLOR_TRANSPARENT,
		WARNING_TIMER, 
		C_COLOR_CHANGE_TO_STICK
	);

	c_time_delete_set(timeDelete, WARNING_TIMER);
}
