/*
 * DESCRIPTION:
 * ecs.c header.
*/

#pragma once

#include "../../GAME.h"

void ecs_register 
(
	enum ECSComponentType type, 
	size_t size, 
	u32 limit,
	ECSFunction add, 
	ECSFunction delete, 
	ECSFunction update_f, 
	ECSFunction update_v,
	ECSFunction draw
);

void ecs_unregister(enum ECSComponentType type);

void ecs_clear(enum ECSComponentType type);
void ecs_delete(u32 id, enum ECSComponentType type);
void ecs_draw(void);
void ecs_update_f(void);
void ecs_update_v(void);
void* ecs_add(u32 id, enum ECSComponentType type);
void* ecs_from_index_get(u32 index, enum ECSComponentType type);
void* ecs_get(u32 id, enum ECSComponentType type);
void ecs_clear_all(void);
