/*
 * DESCRIPTION:
 * Registers ECS components.
*/

#include "ecs_register.h"

static void ecs_register_all(void);

/* Registers all components into the ECS. */
static void
ecs_register_all(void)
{
	for (s32 i = 0; i < ECS_C_COUNT; i++)
	{
		ECSRegister r;

		r = ECS_REGISTERS[i];

		r();
	}
}

/* Initializes ECS. */
void 
ecs_init(void)
{
	ecs_register_all();
}

/* Frees ECS. */
void
ecs_free(void)
{
	for (s32 i = 0; i < ECS_C_COUNT; i++)
		ecs_unregister((enum ECSComponentType)i);
}
