/*
 * DESCRIPTION:
 * ecs_register.c header.
*/

#include "c_chase.h"
#include "c_circle.h"
#include "c_circle_collide.h"
#include "c_color.h"
#include "c_color_change.h"
#include "c_color_collide_delete.h"
#include "c_contact_damage.h"
#include "c_control.h"
#include "c_damage.h"
#include "c_flash.h"
#include "c_game_object.h"
#include "c_health.h"
#include "c_move.h"
#include "c_orbit.h"
#include "c_particle_spawn.h"
#include "c_physics.h"
#include "c_player_atlas_health.h"
#include "c_player_death.h"
#include "c_pulsate.h"
#include "c_rotation.h"
#include "c_scale.h"
#include "c_spin.h"
#include "c_sprite.h"
#include "c_stun.h"
#include "c_text.h"
#include "c_time_delete.h"
#include "c_ui_button.h"

static const ECSRegister ECS_REGISTERS[ECS_C_COUNT] = 
{
	c_chase_register,
	c_circle_collide_register,
	c_circle_register,
	c_color_register,
	c_color_change_register,
	c_color_collide_delete_register,
	c_contact_damage_register,
	c_control_register,
	c_damage_register,
	c_flash_register,
	c_game_object_register,
	c_health_register,
	c_move_register,
	c_orbit_register,
	c_particle_spawn_register,
	c_physics_register,
	c_player_atlas_health_register,
	c_player_death_register,
	c_pulsate_register,
	c_rotation_register,
	c_scale_register,
	c_spin_register,
	c_sprite_register,
	c_stun_register,
	c_text_register,
	c_time_delete_register,
	c_ui_button_register
};

void ecs_free(void);
void ecs_init(void);
