/*
 * DESCRIPTION:
 * Entity functions.
*/

#include "entity.h"

/* Returns a new entity ID. */
u32
entity_add(void)
{
	u32 id;

	id = game.ecs.nextID;

	game.ecs.nextID++;

	return id;
}

/* Removes all components with the specified entity. */
void
entity_delete(u32 id)
{
	/* Will fail if NULL. */
	for (s32 i = 0; i < ECS_C_COUNT; i++)
		ecs_delete(id, (enum ECSComponentType)i);
}
