/*
 * DESCRIPTION:
 * game.c header.
*/

#pragma once

#include "../engine/sdl.h"

#include "ecs/ecs_register.h"

#include "game_state.h"

#define WINDOW_FLAGS SDL_WINDOW_OPENGL
#define WINDOW_MENU "Orbit+"
#define RENDERER_FLAGS SDL_RENDERER_ACCELERATED
#define FRAME_DELAY 16

static const vec4 RENDERER_CLEAR_COLOR = {0.0f, 0.0f, 0.0f, 0.0f};
static const vec3 CAMERA_POSITION_DEFAULT = {0.0f, 0.0f, 0.0f};
static const vec2 WINDOW_SIZE = {1280.0f, 720.0f};
static const vec4 GAME_BOUNDS = {0.0f, 0.0f, 1280.0f, 720.0f};

void game_init(void);
void game_free(void);
void game_loop(void);
