/*
 * DESCRIPTION:
 * Handles loading/freeing game fonts.
*/

#include "game_font.h"

/* Initializes a game font. */
void
game_font_init(enum FontType font)
{
	if (font_init(&game.fonts[font], FONT_PATHS[font], FONT_SIZES[font]))
		printf("LOADED: %s\n", FONT_PATHS[font]);
	else
		printf("FAILED: %s\n", FONT_PATHS[font]);
}

/* Frees a game font. */
void
game_font_free(enum FontType font)
{
	font_free(&game.fonts[font]);

	printf("FREED: %s\n", FONT_PATHS[font]);
}
