/*
 * DESCRIPTION:
 * Handles loading/freeing game music.
*/

#include "game_music.h"

/* Initializes a game music. */
void
game_music_init(enum MusicType music)
{
	if(music_init(&game.music[music], MUSIC_PATHS[music]))
		printf("LOADED: %s\n", MUSIC_PATHS[music]);
	else
		printf("FAILED: %s\n", MUSIC_PATHS[music]);
}

/* Frees a game music. */
void
game_music_free(enum MusicType music)
{
	music_free(&game.music[music]);

	printf("FREED: %s\n", MUSIC_PATHS[music]);
}
