/*
 * DESCRIPTION:
 * game_shader.c header.
*/

#pragma once

#include "../GAME.h"

#define SHADER_PATH_SIZE 64
#define SHADER_BUFFER_SIZE 2048

struct ShaderPaths
{
	const char* vertexPath;
	const char* fragmentPath;
};

struct ShaderData
{
	char vertex[SHADER_BUFFER_SIZE];
	char fragment[SHADER_BUFFER_SIZE];
};

#define SHADER_TEXTURE_QUAD_UNIFORM_MODEL "uModel"
#define SHADER_TEXTURE_QUAD_UNIFORM_PROJECTION "uProjection"
#define SHADER_TEXTURE_QUAD_UNIFORM_VIEW "uView"
#define SHADER_TEXTURE_QUAD_UNIFORM_COLOR "uColor"
#define SHADER_TEXTURE_QUAD_UNIFORM_TEXTURE "uTexture"
static const struct ShaderPaths SHADER_PATHS[SHADER_COUNT] = 
{
	{
		.vertexPath = "res/shader/textureQuad.vs",
		.fragmentPath = "res/shader/textureQuad.fs"
	},
};

void game_shader_data_init(void);
void game_shader_init(enum ShaderType shader);
void game_shader_free(enum ShaderType shader);
