/*
 * DESCRIPTION:
 * Handles loading/freeing game sounds.
*/

#include "game_sound.h"

/* Initializes a game sound. */
void
game_sound_init(enum SoundType sound)
{
	if (sound_init(&game.sounds[sound], SOUND_PATHS[sound]))
		printf("LOADED: %s\n", SOUND_PATHS[sound]);
	else
		printf("FAILED: %s\n", SOUND_PATHS[sound]);
}

/* Frees a game sound. */
void
game_sound_free(enum SoundType sound)
{
	sound_free(&game.sounds[sound]);

	printf("FREED: %s\n", SOUND_PATHS[sound]);
}
