/*
 * DESCRIPTION:
 * Handles loading/freeing game textures.
*/

#include "game_texture.h"

/* Initializes a game texture. */
void
game_texture_init(enum TextureType texture)
{
	if (texture_init(&game.textures[texture], TEXTURE_PATHS[texture]))
		printf("LOADED: %s\n", TEXTURE_PATHS[texture]);
	else
		printf("FAILED: %s\n", TEXTURE_PATHS[texture]);
}

/* Frees a game texture. */
void
game_texture_free(enum TextureType texture)
{
	texture_free(&game.textures[texture]);

	printf("FREED: %s\n", TEXTURE_PATHS[texture]);
}
