/*
 * DESCRIPTION:
 * Game state types.
*/

#pragma once

#include "../../util/UTIL.h"

#define STATE_COUNT STATE_RESULTS + 1
enum StateType
{
	STATE_MENU,
	STATE_PLAY,
	STATE_RESULTS
};

struct Play
{
	u32 playerID;
	u32 scoreID;
	u32 levelID;
	u32 messageID;
	struct Vector enemies; /* entity id */
	u32 score;
	u32 levelTimer;
	u32 level;
	s32 spawnTimer;
	s32 startTimer;
	vec4 bounds;
	bool isOver;
	bool isSpawn;
	bool isStart;
};

struct Menu
{
	u32 logoID;
	u32 startID;
	u32 creditsID;
	bool isMenuDone;
	bool isLogoDone;
	bool isStart;
};

struct Results
{
	u32 scoreID;
	u32 menuID;
	bool isMenu;
};
