/*
 * DESCRIPTION:
 * s_menu.c header.
*/

#pragma once

#include "../ecs/c_color.h"
#include "../ecs/e_logo.h"
#include "../ecs/e_ui_button.h"

#define MENU_TEXT_SELECT_COLOR COLOR_OPAQUE
#define MENU_TEXT_COLOR C_COLOR_VALUES[0]
#define MENU_TEXT_COLOR_CHANGE_BASE_COLOR COLOR_TRANSPARENT
#define MENU_TEXT_COLOR_CHANGE_TIMER 60
#define MENU_TEXT_COLOR_CHANGE_TYPE C_COLOR_CHANGE_TO_STICK

#define MENU_START_ORIGIN ORIGIN_CENTER
#define MENU_START_STRING "Start"
static const vec3 MENU_START_POSITION = {640.0f, 650.0f, 0.0f};

#define MENU_CREDITS_STRING "programming/art: Shweet\nconcept/sound: Jiggmin\nmusic: \"Ethnica\" by NemesisTheory"
#define MENU_CREDITS_ORIGIN ORIGIN_BOTTOM_LEFT
#define MENU_CREDITS_WRAP -1
static const vec3 MENU_CREDITS_POSITION = {20.0f, 700.0f, 0.0f};

#define STATE_MENU_TEXTURE_COUNT 1
static const enum TextureType STATE_MENU_TEXTURES[STATE_MENU_TEXTURE_COUNT] =
{
	TEXTURE_LOGO
};

#define STATE_MENU_SOUND_COUNT 2
static const enum SoundType STATE_MENU_SOUNDS[STATE_MENU_SOUND_COUNT] = 
{
	SOUND_HOVER,
	SOUND_SELECT
};

#define STATE_MENU_FONT_COUNT 2
static const enum FontType STATE_MENU_FONTS[STATE_MENU_FONT_COUNT] =
{
	FONT_SMALL,
	FONT_BIG
};

#define STATE_MENU_SHADER_COUNT 1
static const enum ShaderType STATE_MENU_SHADERS[STATE_MENU_SHADER_COUNT] = 
{
	SHADER_TEXTURE_QUAD
};

void menu_init(struct Menu* self);
void menu_update_f(struct Menu* self);
void menu_free(struct Menu* self);
