/*
 * DESCRIPTION:
 * Results game state.
*/

#include "s_results.h"

/* Updates buttons. */
static void
results_button_update(struct Results* self)
{
	struct CUIButton* menuUIButton;

	menuUIButton = ecs_get(self->menuID, ECS_C_UI_BUTTON);

	if (menuUIButton->isPressed)
		self->isMenu = true;
	
	if (keyboard_press(&game.keyboard, KEYBOARD_SPACE))
		self->isMenu = true;
}

/* Initializes results. */
void
results_init(struct Results* self)
{
	char scoreBuffer[RESULTS_SCORE_BUFFER_SIZE];

	memset(self, '\0', sizeof(struct Results));

	memset(scoreBuffer, '\0', sizeof(char) * RESULTS_SCORE_BUFFER_SIZE);
	snprintf(scoreBuffer, sizeof(char) * RESULTS_SCORE_BUFFER_SIZE, "Your Score: %u", game.score);

	self->scoreID = entity_add();
	self->menuID = entity_add();

	text_init
	(
		self->scoreID, 
		RESULTS_SCORE_ORIGIN,
		game.fonts[RESULTS_SCORE_FONT],
		scoreBuffer,
		strlen(scoreBuffer),
		RESULTS_SCORE_WRAP,
		RESULTS_SCORE_COLOR,
		RESULTS_SCORE_POSITION
	);

	ui_button_init
	(
		self->menuID, 
		RESULTS_MENU_ORIGIN,
		game.fonts[RESULTS_MENU_FONT],
		RESULTS_MENU_STRING,
		strlen(RESULTS_MENU_STRING),
		RESULTS_MENU_COLOR,
		RESULTS_MENU_SELECT_COLOR,
		RESULTS_MENU_POSITION
	);
}

/* Updates results. */
void
results_update_f(struct Results* self)
{
	results_button_update(self);
}

/* Frees results. */
void
results_free(struct Results* self)
{
	entity_delete(self->scoreID);
	entity_delete(self->menuID);
}
