/*
 * DESCRIPTION:
 * s_results.c header.
*/

#pragma once

#include "../ecs/c_color.h"

#include "../ecs/e_text.h"
#include "../ecs/e_ui_button.h"

#define RESULTS_SCORE_BUFFER_SIZE 0xFF
#define RESULTS_SCORE_COLOR C_COLOR_VALUES[0]
#define RESULTS_SCORE_ORIGIN ORIGIN_CENTER
#define RESULTS_SCORE_WRAP -1
#define RESULTS_SCORE_FONT FONT_BIG
static const vec3 RESULTS_SCORE_POSITION = {640.0f, 200.0f, 0.0f};

#define RESULTS_MENU_COLOR C_COLOR_VALUES[0]
#define RESULTS_MENU_FONT FONT_BIG
#define RESULTS_MENU_ORIGIN ORIGIN_CENTER
#define RESULTS_MENU_SELECT_COLOR COLOR_OPAQUE
#define RESULTS_MENU_STRING "Menu"
static const vec3 RESULTS_MENU_POSITION = {640.0f, 600.0f, 0.0f};

#define STATE_RESULTS_SOUND_COUNT 2
static const enum SoundType STATE_RESULTS_SOUNDS[STATE_RESULTS_SOUND_COUNT] = 
{
	SOUND_HOVER,
	SOUND_SELECT
};

#define STATE_RESULTS_FONT_COUNT 1
static const enum FontType STATE_RESULTS_FONTS[STATE_RESULTS_FONT_COUNT] =
{
	FONT_BIG
};

#define STATE_RESULTS_SHADER_COUNT 1
static const enum ShaderType STATE_RESULTS_SHADERS[STATE_RESULTS_SHADER_COUNT] = 
{
	SHADER_TEXTURE_QUAD
};

void results_init(struct Results* self);
void results_update_f(struct Results* self);
void results_free(struct Results* self);
