/*
 * DESCRIPTION:
 * Mathematical constants and macros.
*/

#pragma once

#include <math.h>

#define PI (GLM_PI)
#define TAU (GLM_PI * 2)
#define RADIANS(x) (x * (PI / 180))
#define DEGREES(x) (x * (180 / PI))
#define RADIANS_MIN (0)
#define RADIANS_MAX (TAU)

#define MIN(x, min) (x < min ? min : x)
#define MAX(x, max) (x > max ? max : x)
#define CLAMP(x, min, max) (MIN(MAX(x, max), min))

#define RANDOM_SEED_SET(seed) (srand(seed))
#define RANDOM ((f32)rand() / (f32)RAND_MAX)
#define RANDOM_F32(min, max) ((f32)((RANDOM * (max - min + 1)) + min))
#define RANDOM_S32(min, max) ((s32)((RANDOM * (max - min + 1)) + min))
#define RANDOM_BOOL() (RANDOM_S32(0, 2))

#define DISTANCE_2D(x1, x2, y1, y2) (sqrt(pow(x1 - x2, 2) + pow(y1 - y2, 2)))
#define ATAN(x1, x2, y1, y2) (atan2(y2 - y1, x2 - x1))
