/*
 * DESCRIPTION:
 * Origin functions.
*/

#include "origin.h"

/* Fetches the origin offset of...whatever it is. */
void
origin_2d_get(enum OriginType type, vec2 size, vec2 origin)
{
	switch (type)
	{
		case ORIGIN_CENTER:
		default:
			origin[0] = (size[0] / 2);
			origin[1] = (size[1] / 2);
			break;
		case ORIGIN_TOP_LEFT:
			origin[0] = 0.0f;
			origin[1] = 0.0f;
			break;
		case ORIGIN_TOP_RIGHT:
			origin[0] = size[0];
			origin[1] = 0.0f;
			break;
		case ORIGIN_BOTTOM_LEFT:
			origin[0] = 0.0f;
			origin[1] = size[1];
			break;
		case ORIGIN_BOTTOM_RIGHT:
			origin[0] = size[0];
			origin[1] = size[1];
			break;
	}
}
