/*
 * DESCRIPTION:
 * Header file for vector.c.
*/

#pragma once

#include "UTIL.h"

struct Vector
{
	u32 count;
	u32 limit;
	size_t itemSize;
	void* data;
};

s32 vector_index_get(struct Vector* self, void* data);
size_t vector_size_get(struct Vector* self);
void vector_free(struct Vector* self);
void vector_init(struct Vector* self, size_t size, s32 limit);
void vector_pop(struct Vector* self);
void vector_remove(struct Vector* self, s32 index);
void vector_clear(struct Vector* self);
void vector_remove_from_data(struct Vector* self, void* data);
void* vector_get(struct Vector* self, s32 index);
void* vector_insert(struct Vector* self, void* data, s32 index);
void* vector_push(struct Vector* self, void* data);
void vector_print(struct Vector* self);
